// drag and drop logic

var scrollViewHt = 0,
	touching = false,
	container = null,
	scrollView = null,
	element,
	callback = false,
	contents = [],
	position = {
		elementYStart : 0,
		elementXStart : 0,
		yStart : 0,
		xStart : 0,
		yCurrent : 0,
		xCurrent : 0
	};

var	touchStartHandler = function(_event) {
	var viewPosition = _event.source.convertPointToView(_event, container);
	if (!touching) {
		touching = true;
		element = _event.source;
		if (!element.draggedToPane){
		    element.zIndex = 100; 
			container.add(element);
			contents.push(element);			
			element.left = element.left - (scrollView.contentOffset ? scrollView.contentOffset.x : 0);
			container.addColorBox(element.index);
			element.draggedToPane = true; 
		}
		position.elementYStart = element.top;
		position.elementXStart = element.left;
		position.yStart = viewPosition.y;
		position.xStart = viewPosition.x;
		touchMoveHandler(_event);
	}
}

var	touchMoveHandler = function(_event) {
	var viewPosition = _event.source.convertPointToView(_event, container);
	if (touching) {
		position.yCurrent = viewPosition.y;
		position.xCurrent = viewPosition.x;
		var yDistance = position.yCurrent - position.yStart;
		var xDistance = position.xCurrent - position.xStart;
		_event.source.left = position.elementXStart + xDistance;
        _event.source.top = position.elementYStart + yDistance;
	}
}

var	touchEndHandler = function(_event) {
	var viewPosition = _event.source.convertPointToView(_event, container);
	if (callback) {
		var _data = {
			source : element,
			position : {
				y : position.yCurrent,
				x : position.xCurrent
			}
		};
		callback(_data);
	}
	element = null;
	touching = false;
	position = {
		elementYStart : 0,
		elementXStart : 0,
		yStart : 0,
		xStart : 0,
		yCurrent : 0,
		xCurrent : 0
	};
	currentDragger = null;
};

exports.initialize = function(_container, _scrollView,  _scrollViewHt) {
	container = _container;
	scrollView = _scrollView;
	scrollViewHt = _scrollViewHt
}; 


exports.addBox = function(_element) {
	_element.addEventListener("touchstart", function(e) {
		touchStartHandler(e);
	});
	_element.addEventListener("touchmove", function(e) {
		touchMoveHandler(e);
	});
	_element.addEventListener("touchend", function(e) {
		touchEndHandler(e);
	});
	_element.addEventListener("touchcancel", function(e) {
		touchEndHandler(e);
	});
};
